/*************************************************************************

    File: dpurc-gr-eo.pl
    Copyright (C) 2008 Johannes Dellert

    This file is part of LARA, version 1.0 (August 2008).

*************************************************************************/

/*========================================================================
   Lexicon for Esperanto (adapted from Schubert 1989)
========================================================================*/

% PRONOUNS

word(mi, [prn,mi,sg,nom]) :- !.
word(min, [prn,mi,sg,acc]) :- !.
word(vi, [prn,vi,_,nom]) :- !.
word(vin, [prn,vi,_,acc]) :- !.
word(li, [prn,li,sg,nom]) :- !.
word(lin, [prn,li,sg,acc]) :- !.
word(sxi, [prn,sxi,sg,nom]) :- !.
word(sxin, [prn,sxi,sg,acc]) :- !.
word(gxi, [prn,gxi,sg,nom]) :- !.
word(gxin, [prn,gxi,sg,acc]) :- !.
word(ni, [prn,ni,pl,nom]) :- !.
word(nin, [prn,ni,pl,acc]) :- !.
word(ili, [prn,mi,pl,nom]) :- !.
word(ilin, [prn,mi,pl,acc]) :- !.
word(kiu, [prn,kiu,_,nom]) :- !.
word(kiun, [prn,kiu,_,acc]) :- !.
word(tiu, [prn,tiu,_,nom]) :- !.
word(tiun, [prn,tiu,_,acc]) :- !.
word(iu, [prn,iu,sg,nom]) :- !.
word(iun, [prn,iu,sg,acc]) :- !.
word(iuj, [prn,iu,pl,nom]) :- !.
word(iujn, [prn,iu,pl,acc]) :- !.
word(cxiu, [prn,cxiu,sg,nom]) :- !.
word(cxiun, [prn,cxiu,sg,acc]) :- !.
word(cxiuj, [prn,cxiu,pl,nom]) :- !.
word(cxiujn, [prn,cxiu,pl,acc]) :- !.
word(neniu, [prn,neniu,_,nom]) :- !.
word(neniun, [prn,neniu,_,acc]) :- !.
word(kio, [prn,kio,_,nom]) :- !.
word(tio, [prn,tio,_,nom]) :- !.
word(io, [prn,io,_,nom]) :- !.
word(cxio, [prn,cxio,_,nom]) :- !.
word(nenio, [prn,nenio,_,nom]) :- !.
word(kies, [prn,kies,_,nom]) :- !.
word(ties, [prn,ties,_,nom]) :- !.
word(ies, [prn,ies,_,nom]) :- !.
word(cxies, [prn,cxies,_,nom]) :- !.
word(nenies, [prn,nenies,_,nom]) :- !.
word(ambaux, [prn,ambaux,pl,nom]) :- !.
word(oni,  [prn,oni,sg,nom]).

% PREPOSITIONS

word(al,  [prp,al]) :- !.
word(anstataux,  [prp,anstataux]) :- !.
word(antaux,  [prp,antaux]) :- !.
word(apud,  [prp,apud]) :- !.
word(cxe,  [prp,cxe]) :- !.
word(cxirkaux,  [prp,cxirkaux]) :- !.
word(da,  [prp,da]) :- !.
word(de,  [prp,de]) :- !.
word(dum,  [prp,dum]) :- !.
word(ekster,  [prp,ekster]) :- !.
word(el,  [prp,el]) :- !.
word(en,  [prp,en]) :- !.
word(gxis,  [prp,gxis]) :- !.
word(inter,  [prp,inter]) :- !.
word(je,  [prp,je]) :- !.
word(kontraux,  [prp,kontraux]) :- !.
word(krom,  [prp,krom]) :- !.
word(kun,  [prp,kun]) :- !.
word(kvazaux,  [prp,kvazaux]) :- !.
word(laux, [prp,laux]) :- !.
word(malgraux, [prp,malgraux]) :- !.
word(per,  [prp,per]) :- !.
word(por,  [prp,por]) :- !.
word(post,  [prp,post]) :- !.
word(preter,  [prp,preter]) :- !.
word(pri,  [prp,pri]) :- !.
word(pro,  [prp,pro]) :- !.
word(sen,  [prp,sen]) :- !.
word(sub,  [prp,sub]) :- !.
word(super,  [prp,super]) :- !.
word(sur,  [prp,sur]) :- !.
word(tra,  [prp,tra]) :- !.
word(trans,  [prp,trans]) :- !.

% COORDINATING CONJUNCTIONS BETWEEN VERBS

word(aux,  [konv,aux]).
word(kaj,  [konv,kaj]).
word(nek,  [konv,nek]).
word(sed,  [konv,sed]) :- !.

% COORDINATING CONJUNCTIONS BETWEEN NOUNS

word(aux,  [konn,aux]) :- !.
word(kaj,  [konn,kaj]) :- !.
word(nek,  [konn,nek]) :- !.

% OTHER COORDINATING CONJUNCTIONS

word(minus,  [kon,minus]) :- !.
word(ol,  [kon,ol]) :- !.
word(plus,  [kon,plus]) :- !.

% SUBORDINATING CONJUNCTIONS

word(cxar, [sbk,cxar]) :- !.
word(cxu, [sbk,cxu]) :- !.
word(do, [sbk,do]) :- !.
word(ke, [sbk,ke]) :- !.
word(kvankam, [sbk,kvankam]) :- !.
word(se, [sbk,se]) :- !.
word(tamen, [sbk,tamen]) :- !.

% INTERJECTIONS

word(nu,  [int,nu]) :- !.

% BOUND FUNCTION MORPHEMES

word(cxi,  [fkc,cxi]) :- !.

% ADVERBS

word(kie, [adv,kie]) :- !.
word(tie, [adv,tie]) :- !.
word(ie, [adv,ie]) :- !.
word(cxie, [adv,cxie]) :- !.
word(nenie, [adv,nenie]) :- !.
word(kial, [adv,kial]) :- !.
word(tial, [adv,tial]) :- !.
word(ial, [adv,ial]) :- !.
word(cxial, [adv,cxial]) :- !.
word(nenial, [adv,nenial]) :- !.
word(kiam, [adv,kiam]) :- !.
word(tiam, [adv,tiam]) :- !.
word(iam, [adv,iam]) :- !.
word(cxiam, [adv,cxiam]) :- !.
word(neniam, [adv,neniam]) :- !.
word(kiel, [adv,kiel]) :- !.
word(tiel, [adv,tiel]) :- !.
word(iel, [adv,iel]) :- !.
word(cxiel, [adv,cxiel]) :- !.
word(neniel, [adv,neniel]) :- !.
word(kiom, [adv,kiom]) :- !.
word(tiom, [adv,tiom]) :- !.
word(iom, [adv,iom]) :- !.
word(cxiom, [adv,cxiom]) :- !.
word(neniom, [adv,neniom]) :- !.
word(almenaux, [adv,almenaux]) :- !.
word(ankaux, [adv,ankaux]) :- !.
word(ankoraux, [adv,ankoraux]) :- !.
word(apenaux, [adv,apenaux]) :- !.
word(baldaux, [adv,baldaux]) :- !.
word(des, [adv,des]) :- !.
word(ecx, [adv,ecx]) :- !.
word(for, [adv,for]) :- !.
word(hieraux, [adv,hieraux]) :- !.
word(hodiaux, [adv,hodiaux]) :- !.
word(ja, [adv,ja]) :- !.
word(jam, [adv,jam]) :- !.
word(jen, [adv,jen]) :- !.
word(jes, [adv,jes]) :- !.
word(ju, [adv,ju]) :- !.
word(ĵus, [adv,ĵus]) :- !.
word(mem, [adv,mem]) :- !.
word(morgaux, [adv,morgaux]) :- !.
word(ne,  [adv,ne]) :- !.
word(nun,  [adv,nun]) :- !.
word(nur,  [adv,nur]) :- !.
word(plej,  [adv,plej]) :- !.
word(pli,  [adv,pli]) :- !.
word(plu,  [adv,plu]) :- !.
word(po,  [adv,po]) :- !.
word(preskaux,  [adv,preskaux]) :- !.
word(tre,  [adv,tre]) :- !.
word(tro,  [adv,tro]) :- !.
word(tuj,  [adv,tuj]) :- !.
word(Adverb, [adv,Adverb]) :- sub_atom(Adverb,_,_,0,e).

% NUMERALS

word(nul, [num,nul]) :- !.
word(unu, [num,unu]) :- !.
word(du, [num,du]) :- !.
word(tri, [num,tri]) :- !.
word(kvar, [num,kvar]) :- !.
word(kvin, [num,kvin]) :- !.
word(ses, [num,sep]) :- !.
word(sep, [num,sep]) :- !.
word(ok, [num,ok]) :- !.
word(naux, [num,naux]) :- !.
word(dek, [num,dek]) :- !.
word(cent, [num,cent]) :- !.
word(mil, [num,mil]) :- !.

% ARTICLE

word(la,  [art,la]) :- !.


% NOUNS (open word class defined by morphology)

word(Noun, [sub,Noun,sg,nom]) :- sub_atom(Noun,_,_,0,o).

word(Noun, [sub,Lemma,sg,acc]) :- 
    sub_atom(Noun,Index,_,0,on), 
    CutIndex is Index + 1 ,
    sub_atom(Noun,0,CutIndex,_,Lemma).

word(Noun, [sub,Lemma,pl,nom]) :- 
    sub_atom(Noun,Index,_,0,oj), 
    CutIndex is Index + 1 ,
    sub_atom(Noun,0,CutIndex,_,Lemma).

word(Noun, [sub,Lemma,pl,acc]) :- 
    sub_atom(Noun,Index,_,0,ojn), 
    CutIndex is Index + 1 ,
    sub_atom(Noun,0,CutIndex,_,Lemma).


% ADJECTIVES (open word class defined by morphology)

word(Adjective, [adj,Adjective,sg,nom]) :- sub_atom(Adjective,_,_,0,a).

word(Adjective, [adj,Lemma,sg,acc]) :- 
    sub_atom(Adjective,Index,_,0,an), 
    CutIndex is Index + 1 ,
    sub_atom(Adjective,0,CutIndex,_,Lemma).

word(Adjective, [adj,Lemma,pl,nom]) :- 
    sub_atom(Adjective,Index,_,0,aj), 
    CutIndex is Index + 1 ,
    sub_atom(Adjective,0,CutIndex,_,Lemma).

word(Adjective, [adj,Lemma,pl,acc]) :- 
    sub_atom(Adjective,Index,_,0,ajn), 
    CutIndex is Index + 1 ,
    sub_atom(Adjective,0,CutIndex,_,Lemma).


% VERBS (open word class defined by morphology)

word(Verb, [vrb,Verb,infin]) :- sub_atom(Verb,_,_,0,i).

word(Verb, [vrb,Lemma,pres]) :- 
    sub_atom(Verb,Index,_,0,as), 
    sub_atom(Verb,0,Index,_,Stem), 
    atom_concat(Stem,i,Lemma).

word(Verb, [vrb,Lemma,pret]) :- 
    sub_atom(Verb,Index,_,0,is), 
    sub_atom(Verb,0,Index,_,Stem), 
    atom_concat(Stem,i,Lemma).

word(Verb, [vrb,Lemma,fut]) :- 
    sub_atom(Verb,Index,_,0,os), 
    sub_atom(Verb,0,Index,_,Stem), 
    atom_concat(Stem,i,Lemma).

word(Verb, [vrb,Lemma,cond]) :- 
    sub_atom(Verb,Index,_,0,us), 
    sub_atom(Verb,0,Index,_,Stem), 
    atom_concat(Stem,i,Lemma).

word(Verb, [vrb,Lemma,imp]) :- 
    sub_atom(Verb,Index,_,0,u), 
    sub_atom(Verb,0,Index,_,Stem), 
    atom_concat(Stem,i,Lemma).


/*========================================================================
    Dependency Rules for Esperanto (adapted from Schubert 1989)

    Each rule is of the form 
    dh(Dependent,Head,Headedness,Projectivity,Uniqueness,Label) where

    Dependent and Head are like the lexical entries above,
    Headedness has one of the values free_order, head_initial or head_final,
    Projectivity has one of the values yes or no,
    Uniqueness has one of the values yes or no, and
    Label is a label for the relation established.
========================================================================*/

%% VERB as governor

% Noun as subject of a verb
% --> Fero rustigxas.
dh([sub,_,_,nom],[vrb,_,_],free_order,yes,yes,subj).

% Pronoun as subject of a verb
% --> Gxi kolektigxis.
dh([prn,_,_,nom],[vrb,_,_],free_order,yes,yes,subj).

% Noun as object of a verb
% --> Li acxetis auxton.
dh([sub,_,_,acc],[vrb,_,_],free_order,yes,yes,obj).

% Pronoun as object of a verb
% --> Li acxetis gxin.
dh([prn,_,_,acc],[vrb,_,_],free_order,yes,yes,obj).

% Noun as predicative of "esti"
% --> Li estas prezidanto.
dh([sub,_,_,nom],[vrb,esti,_],free_order,yes,yes,pred).

% Pronoun as predicative of "esti"
% --> Tio estas gxi.
dh([prn,_,_,nom],[vrb,esti,_],free_order,yes,yes,pred).

% Adjective as predicative of "esti"
% --> Gxi estas blua.
dh([adj,_,_,nom],[vrb,esti,_],free_order,yes,yes,pred).

% Preposition as propositional argument of a verb
% --> Li dormis en sia lito.
dh([prp,_],[vrb,_,_],free_order,yes,yes,proa).

% Subordinating conjunction as propositional argument of a verb
% --> Li ne povis veni, do li devis malaligxi.
dh([sbk,_],[vrb,_,_],free_order,yes,yes,proa).

% Adverb as modal adjunct of a verb
% --> Pove, mi ne venos al vi.
dh([adv,_],[vrb,_,_],free_order,yes,yes,moda).


%% NOUN as governor

% Article as determiner of a noun
% --> la domo
dh([art,_],[sub,_,_,_],head_final,yes,yes,det).

% Pronoun as attribute of a noun
% --> iu domo
dh([prn,_,_,Case],[sub,_,_,Case],head_final,yes,yes,atr1).

% Adjective as attribute of a noun
% --> blua domo
dh([adj,_,Number,Case],[sub,_,Number,Case],free_order,yes,no,atr1).

% Numeral as attribute of a noun
% --> unu domo
dh([num,_],[sub,_,_,_],free_order,yes,yes,atr1).

% Preposition as free adjunct of a noun
% --> la auxto de mia amiko
dh([prp,_],[sub,_,_,_],head_initial,yes,yes,adju).

% Verb as relative clause of a noun
% --> domo, kie ni logxas
dh([vrb,_,_],[sub,_,_,_],head_initial,yes,yes,rel).


%% PRONOUN as governor

% Pronoun as attribute of another pronoun
% --> Ili renkontas nin cxiujn.
dh([prn,_,Number,_],[prn,_,Number,_],free_order,yes,yes,atr1).

% Numeral as apposition of a pronoun
% --> Tri iuj
dh([num,_],[prn,_,_,_],head_final,yes,yes,apo).

% Adverb as adjunct of a pronoun
% --> ni cxi tie
dh([adv,_],[prn,_,_,_],head_initial,yes,yes,adju).

% Preposition as adjunct of a pronoun
% --> iu el miaj amikoj
dh([prp,_],[prn,_,_,_],head_initial,yes,yes,adju).


%% PREPOSITION as governor

% Noun in argument position (only accepts nominative case!)
% --> pri domo
dh([sub,_,_,nom],[prp,_],head_initial,yes,yes,parg).


%% SUBORDINATING CONJUNCTION as governor

% Verb as head of the subordinated clause
% --> Mi venos, se mi ricevos bileton.
dh([vrb,_,_],[sbk,_],head_initial,yes,yes,subc).

% Verbal coordination as head of the subordinated clause
% --> Mi venos, se hundo dormos kaj ne mordos min.
dh([konv,_],[sbk,_],head_initial,yes,yes,subc).


%% VERBAL COORDINATION as governor

% Noun as subject of a verbal coordination
% --> Fero rustigxas kaj estis for.
dh([sub,_,_,nom],[konv,_],free_order,yes,yes,subj).

% Pronoun as subject of a verbal coordination
% --> Gxi kolektigxis kaj iris for.
dh([prn,_,_,nom],[konv,_],free_order,yes,yes,subj).

% Noun as object of a verbal coordination
% --> Li acxetis kaj vendis auxtojn.
dh([sub,_,_,acc],[konv,_],free_order,yes,yes,obj).

% Pronoun as object of a verbal coordination
% --> Li acxetis kaj mangxis gxin.
dh([prn,_,_,acc],[konv,_],free_order,yes,yes,obj).

% Preposition as propositional argument of a verbal coordination
% --> Li dormis kaj vivis en sia lito.
dh([prp,_],[konv,_],free_order,yes,yes,proa).

% Verb as left coordinate of a verbal coordination
% --> Ni esperis kaj atendis.
dh([vrb,_,_],[konv,_],head_final,yes,yes,konv1).

% Verb as right coordinate of a verbal coordination
% --> Ni esperis kaj atendis.
dh([vrb,_,_],[konv,_],head_initial,yes,yes,konv2).

